/*	______________________________________________________________________

	imagepak.h  Version 1.01
	(C)2010. Kruchinin Aleksandr. http://vidikon.com
	 -      
	______________________________________________________________________
*/
#ifndef _IMGPAK_
#define _IMGPAK_ 

#include <stdio.h>
#include <math.h>

//#define ON_DEBUG 1

#define PI 3.14159265358979323846

struct F_LINE
{
	int k1;
	int b;
	double b1,b2;
};

struct C_POINT
{
	int x,y;
};

struct C_POINTd
{
	double x,y;
};

//   4 
/*
0 ----- 2
|       |
3 ----- 1
*/
struct FOUR_FIG_P
{
	C_POINT p[4];//0,1  -   2,3 - 
};

struct FOUR_FIG_Pd
{
	C_POINTd p[4];//0,1  -   2,3 - 
};

//   4 
//   02-21-13-30
struct FOUR_FIG_L
{
	F_LINE l[4];
};


//   
F_LINE MakeLine(double x1,double y1,double x2,double y2);
F_LINE MakeLine(C_POINT p1,C_POINT p2);
F_LINE MakeLine(C_POINTd p1,C_POINTd p2);
extern "C"
{
F_LINE MakeLineFromPolar(C_POINTd p1,double f);
}
//        (    ) 
C_POINTd FindPointContinue(C_POINTd p1,C_POINTd p2,F_LINE line,double size);
C_POINTd FindPointContinue_(C_POINTd p1,C_POINTd p2,F_LINE line,double size);

extern "C"
{

int Intersection(F_LINE f1,F_LINE f2,double &x,double &y);//  

//   
double LengthLine(double x1,double y1,double x2,double y2);

// 
float MakePolarR(float x,float y);
float MakePolarF(float x,float y);

#define DIRECT_HOUR_ARROW 0x01	// 
#define DIRECT_HOUR_ARROW_A 0x02	//
//   -     
bool DirectPoint(C_POINT*p,int all,unsigned char flags);

C_POINTd PointID(C_POINT p);
C_POINT PointDI(C_POINTd p);

}

double RToLine(F_LINE f,double x,double y);//    
double RToLine(F_LINE f,C_POINTd p);

extern "C"
{

int round(double param);
double absf(double a);


//  
C_POINTd Average(C_POINTd p1,C_POINTd p2);

//  
F_LINE MakeParallelLine(F_LINE line,C_POINTd point);

//        
double FoundInclination(F_LINE line,F_LINE line1);

//     
F_LINE TurnLine(F_LINE f,double alfa,C_POINTd point);

//   
 F_LINE Approximation(int *array,int all_elem);

}

#include <windows.h>
#include < olectl.h>

#define THRESH_BINARY_INV		1
#define ALLOCATE_WHITE			1

//  24  
struct IMG
{
	byte* bytes;
	int Width;
	int Width_1;
	int Height;
	bool on;
	//    ,    -  24 
	BYTE format;//0 - 24 1 - 8   
};

extern "C"
{

IMG OpenDF(char* filename);

}

int DrawLine(IMG img,F_LINE,byte c1,byte c2,byte c3);
extern "C"
{
int DrawLine(IMG img, C_POINT p1,C_POINT p2,byte c1,byte c2,byte c3);
}
extern "C"
{

int DrawRect(IMG img,RECT rect,byte c1,byte c2,byte c3);


//  
int UpDownImage(IMG img);

// jpeg,gif  bmp
HBITMAP LoadPictureFile(LPCTSTR szFile);
IMG OpenGraphFile(char* filename);
int SaveDF(char* filename,IMG img);
// 
int CopyIMG(IMG in,IMG &out);

//
IMG Transform1(IMG Img);


//  
void ThresholdImage(IMG Img,byte param,RECT rect);
IMG AdaptiveThresholdImage(IMG Img,int block_size,RECT rect,DWORD flags);
void Adaptive2ThresholdImage(IMG Img,byte param,byte delta,RECT rect,int pixels);

// 
void AllocationBorders(IMG img);
void AllocationBordersRect(IMG img,RECT r, DWORD flags);

//      
IMG ReduceImage(IMG img,int param);

//    
IMG IncreaseImg(IMG img,int param);

//  8  
IMG Img24To8(IMG Img);

//  24 
IMG Img8To24(IMG Img);

// 
void ClearImage(IMG img);

// 
void DrawPoint(IMG img,int x,int y,byte c1,byte c2,byte c3);

// 
 void DrawPoint(IMG img,int x,int y,byte c1,byte c2,byte c3);

 void DrawFillRect(IMG Img,RECT Rect,byte c1,byte c2,byte c3);

 void DeleteImg(IMG Img);

//     3  3
IMG Img_Dilate(IMG Img);

//
IMG Img_Erode(IMG Img);

}

class  GRID
{
private:
	int x_size,y_size;
	FOUR_FIG_Pd main_p;
	FOUR_FIG_L main_l;
	//FOUR_FIG_P* p;
	F_LINE* l;
	double* cells;//   
public:
	GRID(int x,int y);//       
	~GRID();//
	int CreateGrid(FOUR_FIG_P pp);//       
	int CreateGrid(FOUR_FIG_Pd pp);//       
	int CreateGrid(FOUR_FIG_Pd pp,F_LINE f1,F_LINE f2,F_LINE f3,F_LINE f4,int*pointer=NULL);//         
	//  
	/*
	0 ----- 2
	|       |
	3 ----- 1
	    0)  0  2; 1)  1  2; 2)  3  0; 3)  3  1.
	  x   0 (         24   ..)
	*/
	F_LINE GetLine(int num);//   
	int RecogCells(IMG img);//   8-  
#ifdef ON_DEBUG
	int RecogCells(IMG img,IMG img24);//   8-  
#endif
	int ReturnBlackCells(double delta);//  -  ,    delta (0-, 1 - )
	void ReturnGrid(double delta,bool &array);//   1-  0 -	
	void ReturnGrid1(double delta,bool &array);// ,    Aztec 
};

extern "C"
{
 int ReturnCountBlackPoints(IMG img,C_POINTd center,double radius,int& all_points,int& black_points,int& border_points);
 int ReturnCountBlackPointsBr(IMG img,C_POINTd center,double radius,int& all_points,int& black_points,int& border_points,C_POINTd &border);

}

#define DIFFERENCE_BLACK_BLACK	1  // ReturnDifference         

extern "C"
{

 F_LINE AccuracyLine(IMG img,F_LINE base_line,C_POINTd point,double alfa,int steps,double Step_line);
 F_LINE AccuracyLine1(IMG img,F_LINE base_line,C_POINTd point,C_POINTd point1,double alfa,int steps);
 F_LINE AccuracyLine2(IMG img,F_LINE base_line,C_POINTd point,C_POINTd point1,double alfa1,double alfa2,int steps);
 F_LINE AccuracyLineBlack(IMG img,F_LINE base_line,C_POINTd point,C_POINTd point1,double alfa1,double alfa2,int steps);
 int BlackWhite(IMG img,int j,int x,int y);
 int OnBlackWhite(IMG img,double x1,double y1,double x2,double y2,F_LINE f3);
 int ReturnDifference(IMG img,double x1,double y1,double x2,double y2,F_LINE f3,DWORD flags);//    

//      8     f   1-   2-
 C_POINTd ReturnFirstPoint(IMG img,F_LINE f,C_POINTd point1,C_POINTd point2,BYTE color,BYTE color1);

//   ,  ReturnDifference
 int *ReturnArrayBlackWhite(DWORD flags);

//          what_cell*10000
 int ReturnNumArray(int num);

}

//    
#define MAX_CONTOUR 10000

//
#define CONTOUR_AUTO_INOUT				0x01     //    



//    
#define MAX_CONTOUR 10000

//
#define CONTOUR_AUTO_INOUT				0x01     //    
#define CONTOUR_CONSISTENTLY			0x02	 //   


struct CONTOUR_STRUCT
{
	WORD all_elem;//     
	C_POINT* Points;//   
	RECT Zone;// 
	int mama;//  -1,   
	int level;// 
};


class  CONTOUR
{
private:
	int all_contour;
	CONTOUR_STRUCT Contours[MAX_CONTOUR];
	//   
	int all_elem;
	C_POINT *Point;
	RECT Zone;
	void FindBorderPoint(int x,int y);
	void FindBorderPoint1(int x,int y);
	byte c1;
	RECT rect;
	//  
	IMG Image;
public:
	CONTOUR();
	~CONTOUR();
	int Find(IMG img,RECT rect,byte c,DWORD flags);//     8 
	int DrawContour(IMG img,int num_counter,byte c1,byte c2,byte c3);// 
	int DrawContours(IMG img,byte c1,byte c2,byte c3);//  
	void ReturnMaxLevel(int &level,int &first,int &all);//         

	C_POINT ReturnCenterContour(int num_con);//  
	bool ReturnPointInContour(C_POINT c,int num_contour);//       
	int GetMama(int num_contour);//  
	int Return4DistantPoints(C_POINT &c_p,int num_contour);// 4      
	int PointsInLine(F_LINE line,int num_contour);//    
	int AllPoints(int num_contour);//  all_elem
	//int MakeSequence(int num_contour);//   
	int Accuracy4RombPoints(C_POINT &c_p,C_POINTd &c_p_d,F_LINE &line,int num_contour);// 4    Return4DistantPoints
	int ReturnAllContours();//   
	RECT ReturnRectContour(int num_con);//   
	int AccuracyLine(C_POINT& c_p,C_POINTd &c_p_d,F_LINE &line,int num_contour,int &all_point,double &result,DWORD flags=0);// -          - 
};

 double M_e(int all,double*ptr);
 double D_e(int all,double*ptr,double M);

 double M_e(int all,int*ptr);
 double D_e(int all,int*ptr,double M);

extern "C"
{

// +1  -1     
 double pmu(double a);

//
 double min_(double,double);
 double max_(double,double);
}

 double KPK_e(int all,int *p,int *p1,double m,double m1,double d,double d1);
 double KPK_e(int all,double *p,double *p1,double m,double m1,double d,double d1);

#define HIST_COMP_CHISQR			1


struct HISTO_1D
{
	int AllElem;
	long pixels;
	int *data;
};
extern "C"
{

 HISTO_1D MakeHistogramIMG(IMG Img,RECT Rect,int AllElem);//   8- 
 HISTO_1D CreateHistogram(int AllElem);//  
 void DeleteHistogram(HISTO_1D h);// 
 int DrawHistogram(HISTO_1D h,IMG Img);//     24- 
 int MaxHistogramElem(HISTO_1D h);//    
 double CompareHist(HISTO_1D h1,HISTO_1D h2,DWORD flags);

//
 double CompareHistogram(HISTO_1D h1,HISTO_1D h2);//  
 int CompareHistogram1(HISTO_1D h1,HISTO_1D h2,double threshold);//   
}

#define SEG_NO_SMALL			1
#define SEG_BINARY_ON			2
#define SEG_BINARY_FULL			4
#define SEG_BINARY_MAX			8

//,  
struct SEGMENTSH
{
	int AllDifSeg;
	int Width,Height;
	int* ptr;
	bool* binary;
};
extern "C"
{


 void DrawSegmentsH(IMG Img,SEGMENTSH ss,int Segment/**/,DWORD flags=0);//    24
 SEGMENTSH SegmentationH(IMG Img,int Segment,int Hist,double param,double Binary,DWORD flags=0);// 
 void DeleteSegmentsh(SEGMENTSH ss);// 
 int ReturnRectSegmentsh(SEGMENTSH ss,int Segment/**/,RECT &Rect,int elem,int maxrect,DWORD flags=0);//     
}

#define AUP_ONE_COLOR 1 
extern "C"
{


 int AllocationUnknownPixels(IMG Img1,IMG Img2,BYTE flags);

 C_POINTd CentreWeights(IMG Img);//    - *  )
}


extern "C"
{

void DeleteByte(unsigned char*pointer);

}

#define MAX_DETECTED_CODE 10

extern "C"
{
//  
int DetectCode(IMG image_code,int reduce,int &AllDetectedCode,RECT *DetectedCode);

}


#endif