/*	______________________________________________________________________

	contour.cpp  Version 1.01
	(C)2010. Kruchinin Aleksandr. http://vidikon.com
	  
	______________________________________________________________________
*/
#include "contour.h"

//long test_test=0;
//
CONTOUR::CONTOUR()
{
	all_contour=0;
}


//
CONTOUR::~CONTOUR()
{
	if (all_contour>0)
		for(int i=0;i<all_contour;i++)
			delete Contours[i].Points;
}

// 
// ( )-    1
//flags
int CONTOUR::Find(IMG img,RECT r,byte c,DWORD flags)
{
	if (img.format!=1) return 1;// 
	rect=r;

	//      
	int i,j;
	int w=(rect.right-rect.left);
	all_elem=0;
	Point= new C_POINT[(rect.right-rect.left)*(rect.bottom-rect.top)/2];
	CopyIMG(img,Image);
	c1=c;
	for(i=rect.top;i<rect.bottom;i++)
	{
		for(j=rect.left;j<rect.right;j++)
		{
			if (Image.bytes[j+i*Image.Width_1]==c1 )
			{
				Image.bytes[j+i*Image.Width_1]=1;
				Point[all_elem].x=j;				
				Point[all_elem].y=i;
				all_elem++;
				Zone.left=j;Zone.right=j;
				Zone.top=i;Zone.bottom=i;
				//    
				if ((CONTOUR_CONSISTENTLY&flags)==CONTOUR_CONSISTENTLY)	FindBorderPoint1(j,i);			
				FindBorderPoint(j,i);
				//     
				Contours[all_contour].Zone=Zone;
				Contours[all_contour].all_elem=all_elem;
				Contours[all_contour].Points=new C_POINT[all_elem];
				memcpy((void*)Contours[all_contour].Points,(void*)Point,sizeof(C_POINT)*all_elem);
				Contours[all_contour].mama=-1;
				Contours[all_contour].level=0;
				all_contour++;
				if (all_contour==MAX_CONTOUR) 
				{
					delete Point;
					delete Image.bytes;
					return 2;
				}
				all_elem=0;
			}
		}
	}

	delete Point;
	delete Image.bytes;

	if ((CONTOUR_AUTO_INOUT&flags)==CONTOUR_AUTO_INOUT)
	{
		//   
		//        
		int k;
		for(i=1;i<all_contour;i++)
		{
			k=-1;
			for(j=0;j<i;j++)
			{
				if (Contours[i].Zone.left>Contours[j].Zone.left && Contours[i].Zone.right<Contours[j].Zone.right &&
					Contours[i].Zone.top>Contours[j].Zone.top && Contours[i].Zone.bottom<Contours[j].Zone.bottom)
				{
					if (k==-1) k=j;
					else if (Contours[j].level>Contours[k].level) k=j;
				}
			}
			if (k>-1)
			{
				Contours[i].mama=k;
				Contours[i].level=Contours[k].level+1;
			}
			else
			{
				Contours[i].mama=-1;
				Contours[i].level=0;
			}
		}
	}
#ifdef ON_DEBUG
	for( i=0;i<all_contour;i++)
	{
		printf("N:%d - L:%d - M:%d\n",i,Contours[i].level,Contours[i].mama);
	}
#endif
	return 0;
}

//      `
// 2.3


#define MAX_BPOINT 20000

void CONTOUR::FindBorderPoint(int x,int y)
{
	int i,j;
	//test_test++;

	WORD k=0;//         
	int k1;
	int w=(rect.right-rect.left);

	int x1[MAX_BPOINT],y1[MAX_BPOINT];
	int all=0;
	
	do{
	k1=0;
	for(i=0;i<3;i++)
		for(j=0;j<3;j++)
		{
			// 8 ,  9 			
			if ((i==1 && j==1) || (j==0 && x==rect.left) || (j==2 && x==rect.right)
				|| (i==0 && y==rect.top) || (i==2 && y==rect.bottom)) continue;			
			k=k*2;
			if (Image.bytes[x-1+j+(y-1+i)*Image.Width_1]==c1)
			{
				Image.bytes[x-1+j+(y-1+i)*Image.Width_1]=1;
				k++;
				Point[all_elem].x=x-1+j;				
				Point[all_elem].y=y-1+i;
				// - 
				if (Point[all_elem].x<Zone.left) Zone.left=Point[all_elem].x;
				if (Point[all_elem].x>Zone.right) Zone.right=Point[all_elem].x;
				if (Point[all_elem].y<Zone.top) Zone.top=Point[all_elem].y;
				if (Point[all_elem].y>Zone.bottom) Zone.bottom=Point[all_elem].y;
				all_elem++;
				k1++;
			}
		}
	if (k1==0) {
		if (all<1) return;
		x=x1[all-1];
		y=y1[all-1];
		all--;
		continue;
	}
	for(i=2;i>=0;i--)
		for(j=2;j>=0;j--)
		{
			if (i==1 && j==1) continue;
			if (x-1+j<0 || x-1+j>=rect.right || y-1+i<0 || y-1+i>=rect.bottom) continue; 
			if (k%2==1) {
				k1--;
				if (k1==0)
				{
					//     
					x=x-1+j;y=y-1+i;
					break;
				}
				//FindBorderPoint(x-1+j,y-1+i);
				//     
				x1[all]=x-1+j;
				y1[all]=y-1+i;
				all++;				
				if (all>=MAX_BPOINT) return;
			}
			k=k/2;
		}
	}while(1);	
}

#define MAX_D_POINT 1000

//    
void CONTOUR::FindBorderPoint1(int x,int y)
{
	//     
	int width=(rect.right-rect.left);
	BYTE *array=new BYTE[width*(rect.bottom-rect.top+1)];

	memset((void*)array,0,width*(rect.bottom-rect.top+1));

	int all_d_point=0; 
	int i1,j1;

	i1=y;j1=x;
	array[j1+i1*width]=1;
	int ll=0;
	int er1=0;
	int k,xP,yP;
	int x_d_point[MAX_D_POINT],y_d_point[MAX_D_POINT];
	do{
		k=0;
		xP=j1;
		yP=i1;
		if (xP<rect.right)
		if (Image.bytes[yP*Image.Width_1+(xP+1)]==c1 && array[(yP-rect.top)*width+xP-rect.left+1]==0) { k=1; j1++;}
		if (xP<rect.right && yP<rect.top)
			if (Image.bytes[(yP+1)*Image.Width_1+(xP+1)]==c1 && array[(yP+1-rect.top)*width+xP-rect.left+1]==0)
			{
				if (k==1) k=2;
				if (k==0) { k=1; j1++; i1++;}						
			}
		if (yP<rect.top)
			if (Image.bytes[(yP+1)*Image.Width_1+(xP)]==c1 && array[(yP+1-rect.top)*width+xP-rect.left]==0)
			{
				if (k==1) k=2;
				if (k==0) { k=1; i1++;}						
			}
		if (xP>rect.left && yP<rect.top)
			if (Image.bytes[(yP+1)*Image.Width_1+(xP-1)]==c1 && array[(yP+1-rect.top)*width+xP-1-rect.left]==0)
			{
				if (k==1) k=2;
				if (k==0) { k=1; i1++; j1--;}						
			}
		if (xP>rect.left)
			if (Image.bytes[(yP)*Image.Width_1+(xP-1)]==c1 && array[(yP-rect.top)*width+xP-1-rect.left]==0)
			{
				if (k==1) k=2;
				if (k==0) { k=1; j1--;}						
			}
		if (xP>rect.left && yP>rect.top)
			if (Image.bytes[(yP-1)*Image.Width_1+(xP-1)]==c1 && array[(yP-1-rect.top)*width+xP-1-rect.left]==0)
			{
				if (k==1) k=2;
				if (k==0) { k=1; i1--; j1--;}						
			}
		if (yP>rect.top)
			if (Image.bytes[(yP-1)*Image.Width_1+(xP)]==c1 && array[(yP-1-rect.top)*width+xP-rect.left]==0)
			{
				if (k==1) k=2;
				if (k==0) { k=1; i1--;}						
			}
		if (xP<rect.right && yP>rect.top)
			if (Image.bytes[(yP-1)*Image.Width_1+(xP+1)]==c1 && array[(yP-1-rect.top)*width+xP+1-rect.left]==0)
			{
				if (k==1) k=2;
				if (k==0) { k=1; i1--; j1++;}						
			}
		if (k>0)	
		{
			ll++;			
			array[(i1-rect.top)*width+j1-rect.left]=1;
			//    
			Point[all_elem].x=j1;				
			Point[all_elem].y=i1;
			all_elem++;
		}
		if (k==2)
		{
			// 
			if (all_d_point<MAX_D_POINT)
			{
				x_d_point[all_d_point]=xP;
				y_d_point[all_d_point]=yP;
				all_d_point++;
			}
		}
		if (k==0)
		{
			if (all_d_point==0) break;
			all_d_point--;
			i1=y_d_point[all_d_point];
			j1=x_d_point[all_d_point];
		}

	}while(1);

	delete array;
}

//   
//  24  
int CONTOUR::DrawContour(IMG img,int num_counter,byte c1,byte c2,byte c3)
{
	if (all_contour-1<num_counter) return 1;
	int i;
	for(i=0;i<Contours[num_counter].all_elem;i++)
			img.bytes[Contours[num_counter].Points[i].x*3+Contours[num_counter].Points[i].y*img.Width_1]=255;
	return 0;
}

//  
int CONTOUR::DrawContours(IMG img,byte c1,byte c2,byte c3)
{
	int i,j;
	for(j=0;j<all_contour;j++)
	for(i=0;i<Contours[j].all_elem;i++)
			img.bytes[Contours[j].Points[i].x*3+Contours[j].Points[i].y*img.Width_1]=255;
	return 0;
}



void CONTOUR::ReturnMaxLevel(int &level,int &first,int &all)
{
	int i,k,kmax;
	k=1;kmax=0;
	for(i=1;i<all_contour;i++)
	{
		if (Contours[i].level==Contours[kmax].level) k++;
		if (Contours[i].level>Contours[kmax].level)
		{
			kmax=i;
			k=1;
		}
	}
	first=kmax;
	level=Contours[kmax].level;
	all=k;
}

C_POINT CONTOUR::ReturnCenterContour(int num_con)
{
	C_POINT c;
	c.x=-1;c.y=-1;

	if (num_con>=all_contour) return c;

	c.x=(Contours[num_con].Zone.right+Contours[num_con].Zone.left)/2;
	c.y=(Contours[num_con].Zone.bottom+Contours[num_con].Zone.top)/2;

	return c;
}

bool CONTOUR::ReturnPointInContour(C_POINT c,int num_contour)
{
	if (num_contour>=all_contour) return false;
	for(int i=0;i<Contours[num_contour].all_elem;i++)
		if (c.x==Contours[num_contour].Points[i].x && c.y==Contours[num_contour].Points[i].y) return true;
	return false;
}

int CONTOUR::GetMama(int num_contour)
{
	return Contours[num_contour].mama;
}

int CONTOUR::Return4DistantPoints(C_POINT &c_p,int num_contour)
{
	int i,j,k;
	C_POINT c[8];
	C_POINT* c1=&c_p;
	for(i=0;i<8;i++) 
	{
		c[i].x=Contours[num_contour].Points[0].x;
		c[i].y=Contours[num_contour].Points[0].y;
	}

	for(i=1;i<Contours[num_contour].all_elem;i++)
	{
		//  8  
		if (Contours[num_contour].Points[i].x<c[0].x) 
		{ c[0].x=Contours[num_contour].Points[i].x; c[0].y=Contours[num_contour].Points[i].y;}
		if (Contours[num_contour].Points[i].x>c[1].x) 
		{ c[1].x=Contours[num_contour].Points[i].x; c[1].y=Contours[num_contour].Points[i].y;}
		if (Contours[num_contour].Points[i].y<c[2].y) 
		{ c[2].x=Contours[num_contour].Points[i].x; c[2].y=Contours[num_contour].Points[i].y;}
		if (Contours[num_contour].Points[i].y>c[3].y) 
		{ c[3].x=Contours[num_contour].Points[i].x; c[3].y=Contours[num_contour].Points[i].y;}
		//if (Contours[num_contour].Points[i].x<c[4].x && Contours[num_contour].Points[i].y<c[4].y) 
		if (LengthLine(0,0,Contours[num_contour].Points[i].x,Contours[num_contour].Points[i].y) <
			LengthLine(0,0,c[4].x,c[4].y))
		{ c[4].x=Contours[num_contour].Points[i].x; c[4].y=Contours[num_contour].Points[i].y;}
		//if (Contours[num_contour].Points[i].x>c[5].x && Contours[num_contour].Points[i].y<c[5].y) 
		if (LengthLine(rect.right,0,Contours[num_contour].Points[i].x,Contours[num_contour].Points[i].y) <
			LengthLine(rect.right,0,c[5].x,c[5].y))
		{ c[5].x=Contours[num_contour].Points[i].x; c[5].y=Contours[num_contour].Points[i].y;}
		//if (Contours[num_contour].Points[i].x>c[6].x && Contours[num_contour].Points[i].y>c[6].y) 
		if (LengthLine(0,rect.bottom,Contours[num_contour].Points[i].x,Contours[num_contour].Points[i].y) <
			LengthLine(0,rect.bottom,c[6].x,c[6].y))
		{ c[6].x=Contours[num_contour].Points[i].x; c[6].y=Contours[num_contour].Points[i].y;}
		//if (Contours[num_contour].Points[i].x<c[7].x && Contours[num_contour].Points[i].y>c[7].y) 
		if (LengthLine(rect.right,rect.bottom,Contours[num_contour].Points[i].x,Contours[num_contour].Points[i].y) <
			LengthLine(rect.right,rect.bottom,c[7].x,c[7].y))
		{ c[7].x=Contours[num_contour].Points[i].x; c[7].y=Contours[num_contour].Points[i].y;}
	}
	//        
	double a,a1=0;
	k=-1;
	int i1,j1;
	i1=-1;j1=-1;
	for(i=0;i<7;i++)
		for(j=i+1;j<8;j++)
		{
			if (c[i].x==c[j].x && c[i].y==c[j].y) continue;
			a=(double)sqrt((double)pow((double)(c[j].y-c[i].y),2)+(double)pow((double)(c[j].x-c[i].x),2));
			if (k==-1)
			{
				a1=a;
				i1=i;j1=j;
				k=1;
				continue;
			}
			if (a>a1)
			{
				a1=a;
				i1=i;j1=j;
			}

		}
	if (j1==-1 || i1==-1) return 1;
	//         

	F_LINE f=MakeLine(c[j1].x,c[j1].y,c[i1].x,c[i1].y);

	a1=0;
	double a2=0;
	int i2=-1,j2=-1;

	for(i=0;i<8;i++)
	{
		if (i==i1 || i==j1) continue;
		a=(double)sqrt((double)pow((double)(c[j1].y-c[i].y),2)+(double)pow((double)(c[j1].x-c[i].x),2))+
			(double)sqrt((double)pow(((double)c[i1].y-c[i].y),2)+(double)pow((double)(c[i1].x-c[i].x),2));
		if ((f.b==1 && ((double)c[i].y-f.b1*c[i].x)>f.b2 && a>a1) ||
			(f.b==2 && ((double)c[i].x-f.b1*c[i].y)>f.b2 && a>a1))
		{
			a1=a;
			i2=i;
		}
		if ((f.b==1 && ((double)c[i].y-f.b1*c[i].x)<f.b2 && a>a2) ||
			(f.b==2 && ((double)c[i].x-f.b1*c[i].y)<f.b2 && a>a2))// 3.2
		{
			a2=a;
			j2=i;
		}
	}
	if (j2==-1 || i2==-1) return 2;

	c1[0]=c[i1];
	c1[1]=c[j1];
	c1[2]=c[i2];
	c1[3]=c[j2];

	return 0;

}


int CONTOUR::PointsInLine(F_LINE line,int num_contour)//    
{
	int i,j;
	double j1;
	int k=0;
	for(i=0;i<Contours[num_contour].all_elem;i++)
	{
		if (line.b==1)
		{
			j1=(double)line.b1*(Contours[num_contour].Points[i].x+0.5)+line.b2;
			j=j1;
			if (Contours[num_contour].Points[i].y==j) k++;
		}
		if (line.b==2)
		{
			j1=(double)line.b1*(Contours[num_contour].Points[i].y+0.5)+line.b2;
			j=j1;
			if (Contours[num_contour].Points[i].x==j) k++;
		}
	}
	return k;
}

int CONTOUR::AllPoints(int num_contour)//  all_elem
{
	return Contours[num_contour].all_elem;
}


int CONTOUR::Accuracy4RombPoints(C_POINT &c_p,C_POINTd &c_p_d,F_LINE &line,int num_contour)// 4    Return4DistantPoints
{
	F_LINE *line1=&line;
	F_LINE romb[4];
	C_POINT* c_p1=&c_p;
	C_POINTd* c_p1_d=&c_p_d;
	C_POINT poi[8];

	// 
	CONTOUR_STRUCT cont;
	cont.Points=new C_POINT[Contours[num_contour].all_elem];

	int i,j;
	int i1,j1;
	C_POINT p1,p2;
	RECT r;
	F_LINE comb_line;
	int comb_all_elem;
	F_LINE comb_line1;
	int comb_all_elem1;
	int i2,j2;
	for(i=0;i<4;i++)
	{
		switch (i)
		{
		case 0:
			p1=c_p1[0];p2=c_p1[2];break;
		case 1:
			p1=c_p1[0];p2=c_p1[3];break;
		case 2:
			p1=c_p1[1];p2=c_p1[2];break;
		case 3:
			p1=c_p1[1];p2=c_p1[3];break;
		}
		romb[i]=MakeLine(p1,p2);
		//      
		// RECT
		if (p1.x<p2.x) {r.left=p1.x;r.right=p2.x;}
		else {r.left=p2.x;r.right=p1.x;}
		if (p1.y<p2.y) {r.top=p1.y;r.bottom=p2.y;}
		else {r.top=p2.y;r.bottom=p1.y;}
		// rect  -  
		if (r.right-r.left<8 && r.bottom-r.top<8) 
		{
			delete cont.Points;
			return 1;//      
		}
		if (romb[i].b==1)
		{
			r.left+=2;
			r.right-=2;
			if (r.bottom-r.top<8)
			{
				r.top-=2;
				r.bottom+=2;
			}
		}
		if (romb[i].b==2)
		{
			r.top+=2;
			r.bottom-=2;
			if (r.right-r.left<8)
			{
				r.left-=2;
				r.right+=2;
			}
		}		
		//   RECT   
		cont.all_elem=0;
		for(j=0;j<Contours[num_contour].all_elem;j++)
			if (Contours[num_contour].Points[j].x>=r.left && Contours[num_contour].Points[j].x<=r.right &&
				Contours[num_contour].Points[j].y>=r.top  && Contours[num_contour].Points[j].y<=r.bottom)
			{
				cont.Points[cont.all_elem]=Contours[num_contour].Points[j];
				cont.all_elem++;
			}
		//   -     
		if (cont.all_elem<8)
		{
			//
			delete cont.Points;
			return 2;//      
		}
		// 8 
		for(j=0;j<8;j++)
			poi[j]=cont.Points[cont.all_elem*j/8];
		// 8-  - 8 
		for(j=0;j<8;j++)
		{
			if (j<4) { i1=j;j1=j+4;}
			else { i1=(j-4)*2;j1=(j-4)*2+1;}
			//           
			comb_line=MakeLine(poi[i1],poi[j1]);
			comb_all_elem=PointsInLine(comb_line,num_contour);
			if (j==0 || comb_all_elem>comb_all_elem1) 
			{
				i2=i1;j2=j1;
				comb_line1=comb_line;comb_all_elem1=comb_all_elem;
			}
		}
		// 
		line1[i]=comb_line1;
	}

	//     
	double x,y;
	Intersection(line1[0],line1[1],x,y);c_p1[0].x=round(x);c_p1[0].y=round(y);
	c_p1_d[0].x=x;c_p1_d[0].y=y;
	Intersection(line1[2],line1[3],x,y);c_p1[1].x=round(x);c_p1[1].y=round(y);
	c_p1_d[1].x=x;c_p1_d[1].y=y;
	Intersection(line1[0],line1[2],x,y);c_p1[2].x=round(x);c_p1[2].y=round(y);
	c_p1_d[2].x=x;c_p1_d[2].y=y;
	Intersection(line1[1],line1[3],x,y);c_p1[3].x=round(x);c_p1[3].y=round(y);
	c_p1_d[3].x=x;c_p1_d[3].y=y;

	delete cont.Points;

	return 0;
}


int CONTOUR::ReturnAllContours(){
	return all_contour;
}
RECT CONTOUR::ReturnRectContour(int num_con){
	RECT r; r.left=-1;
	if (num_con>=all_contour) return r;

	return Contours[num_con].Zone;
}

/*
  -   c_p   
  -   c_p  -     
 0 -  
1 -  
4 -   s
*/
int CONTOUR::AccuracyLine(C_POINT& c_p,C_POINTd &c_p_d,F_LINE &line,int num_contour,int &all_point,double &result,DWORD flags)
{
	F_LINE *line1=&line;
	C_POINT* c_p_=&c_p;
	F_LINE line__;
	C_POINTd* c_p1_d=&c_p_d;
	RECT r;
	C_POINT poi[8];
	F_LINE comb_line;
	int comb_all_elem;
	line__=MakeLine(c_p_[0],c_p_[1]);
	//        
	// RECT
	/*if (c_p_[0].x<c_p_[1].x) {r.left=c_p_[0].x;r.right=c_p_[1].x;}
	else {r.left=c_p_[1].x;r.right=c_p_[0].x;}
	if (c_p_[0].y<c_p_[1].y) {r.top=c_p_[0].y;r.bottom=c_p_[1].y;}
	else {r.top=c_p_[1].y;r.bottom=c_p_[0].y;}
	// rect  -  
	if (r.right-r.left<8 && r.bottom-r.top<8) 
	{
		return 1;//      
	}
	if (line__.b==1)
	{
		r.left+=2;
		r.right-=2;
		if (r.bottom-r.top<8)
		{
			r.top-=2;
			r.bottom+=2;
		}
	}
	if (line__.b==2)
	{
		r.top+=2;
		r.bottom-=2;
		if (r.right-r.left<8)
		{
			r.left-=2;
			r.right+=2;
		}
	}*/
	int j,i;		

	if ((CONTOUR_CONSISTENTLY&flags)==CONTOUR_CONSISTENTLY)	
	{
		long kk1=-1,kk2=-1,kk3;
		for(j=0;j<Contours[num_contour].all_elem;j++)		
			if (c_p_[0].x==Contours[num_contour].Points[j].x || c_p_[0].y==Contours[num_contour].Points[j].y)
			{
				kk1=j;break;
			}
		for(j=0;j<Contours[num_contour].all_elem;j++)		
			if (c_p_[1].x==Contours[num_contour].Points[j].x || c_p_[1].y==Contours[num_contour].Points[j].y)
			{
				kk2=j;break;
			}
		if (kk1==-1 || kk2==-1) return 6;
		if (kk1>kk2) {
			kk3=kk1;
			kk1=kk2;
			kk2=kk3;
		}
		double rrr=min_(kk2-kk1,Contours[num_contour].all_elem-kk2+kk1);	
		double rrr1=max_(abs(c_p_[0].x-c_p_[1].x),abs(c_p_[0].y-c_p_[1].y));
		if (rrr1>rrr) return 11;
		if ((double)1.5*rrr1<(double)rrr) return 12;
		all_point=rrr;
		result=(double)rrr/rrr1;//(double)cont.all_elem/rrr;
		c_p1_d[1]=PointID(c_p_[1]);
		c_p1_d[0]=PointID(c_p_[0]);
		line1[0]=line__;
		return 0;
	}
	
	CONTOUR_STRUCT cont;
	cont.Points=new C_POINT[Contours[num_contour].all_elem];
	cont.all_elem=0;	
	double rr;	
	double ii,ii1,ii2;
	ii=(double)LengthLine(c_p_[0].x,c_p_[0].y,c_p_[1].x,c_p_[1].y);

	long rrr1_=ii;
	int *array=new int[rrr1_+1];
	memset((void*)array,0,(rrr1_+1)*sizeof(int));
	int kkk;

	for(j=0;j<Contours[num_contour].all_elem;j++)
	{		
	//	if (Contours[num_contour].Points[j].x>=r.left && Contours[num_contour].Points[j].x<=r.right &&
	//		Contours[num_contour].Points[j].y>=r.top  && Contours[num_contour].Points[j].y<=r.bottom)
		rr=RToLine(line__,Contours[num_contour].Points[j].x,Contours[num_contour].Points[j].y);
		if (RToLine(line__,Contours[num_contour].Points[j].x,Contours[num_contour].Points[j].y)<5)
		{
			cont.Points[cont.all_elem]=Contours[num_contour].Points[j];
			cont.all_elem++;	
			kkk=LengthLine(c_p_[0].x,c_p_[0].y,Contours[num_contour].Points[j].x,Contours[num_contour].Points[j].y);
			if (kkk>rrr1_) continue;
			array[kkk]++;
		}
	}

	//   -     
	if (cont.all_elem<8)
	{
		//
		delete cont.Points;
		delete array;
		return 2;//      
	}
	
	if (ii*0.5>(double)cont.all_elem) {
		delete cont.Points;
		delete array;
		return 5;
	}

	int i1,j1;
	int i2,j2,k;
	F_LINE comb_line1;
	int comb_all_elem1;
	// 8 
	for(j=0;j<8;j++)
		poi[j]=cont.Points[cont.all_elem*j/8];
	// 8-  - 8 
	k=0;
	for(j=0;j<8;j++)
	{
		if (j<4) { i1=j;j1=j+4;}
		else { i1=(j-4)*2;j1=(j-4)*2+1;}
		//           
		comb_line=MakeLine(poi[i1],poi[j1]);
		comb_all_elem=PointsInLine(comb_line,num_contour);
		if (j==0 || comb_all_elem>comb_all_elem1) 
		{
			i2=i1;j2=j1;
			comb_line1=comb_line;
			comb_all_elem1=comb_all_elem;
			//
		}
	}
	//           	
	if (ii*0.1>(double)comb_all_elem1) {
		delete cont.Points;
		return 3;
	}
	if (FoundInclination(line__,comb_line1)>PI/8) {
		delete cont.Points;
		delete array;
		return 4;
	}

	//      -   - 
	double m_=M_e(rrr1_+1,array);
	double d_=D_e(rrr1_+1,array,m_);
	result=d_;
	
	
	// 
	line1[0]=comb_line1;

	//     -   
	i=-1;i1=0;
	for(j=0;j<Contours[num_contour].all_elem;j++)
	{
		//    
		k=0;
		/*if (Contours[num_contour].Points[j].x==244 && Contours[num_contour].Points[j].y==722)
		{
			k=k;
		}*/
		if (line1[0].b==1)
		{
			ii=(double)line1[0].b1*(Contours[num_contour].Points[j].x+0.5)+line1[0].b2;
			
			if (absf(Contours[num_contour].Points[j].y-ii)<=2) k=1;
		}
		if (line1[0].b==2)
		{
			ii=(double)line1[0].b1*(Contours[num_contour].Points[j].y+0.5)+line1[0].b2;			
			if (absf(Contours[num_contour].Points[j].x-ii)<=2) k=1;
		}
		if (k==0) continue;
		if (i==-1) 
		{
			i=j;
			ii1=LengthLine(c_p_[0].x,c_p_[0].y,Contours[num_contour].Points[j].x,Contours[num_contour].Points[j].y);
		}
		else
		{
			if (ii1<LengthLine(c_p_[0].x,c_p_[0].y,Contours[num_contour].Points[j].x,Contours[num_contour].Points[j].y))
			{
				i=j;
				ii1=LengthLine(c_p_[0].x,c_p_[0].y,Contours[num_contour].Points[j].x,Contours[num_contour].Points[j].y);
			}
		}
		if (i1==-1) 
		{
			i1=j;
			ii2=LengthLine(c_p_[1].x,c_p_[1].y,Contours[num_contour].Points[j].x,Contours[num_contour].Points[j].y);
		}
		else
		{
			if (ii2<LengthLine(c_p_[1].x,c_p_[1].y,Contours[num_contour].Points[j].x,Contours[num_contour].Points[j].y))
			{
				i1=j;
				ii2=LengthLine(c_p_[1].x,c_p_[1].y,Contours[num_contour].Points[j].x,Contours[num_contour].Points[j].y);
			}
		}
	}

	c_p1_d[1]=PointID(Contours[num_contour].Points[i]);
	c_p1_d[0]=PointID(Contours[num_contour].Points[i1]);

	all_point=cont.all_elem;
	

	

	delete cont.Points;
	delete array;

	return 0;
}
