/*	______________________________________________________________________

	geoman.cpp  Version 1.01
	(C)2010. Kruchinin Aleksandr. http://vidikon.com
	 	
	______________________________________________________________________
*/

#include "geoman.h"

#define MAX_STEPS 100

#define MAX_CELL_LATTICE 1280 //       8

int leng_cell[MAX_CELL_LATTICE];
bool what_cell[MAX_CELL_LATTICE];
int all_cell;



/*
base_line -  ,   ,
point -     
alfa -   
steps -   ()   
Step_line -     
*/
F_LINE AccuracyLine(IMG img,F_LINE base_line,C_POINTd point,double alfa,int steps,double Step_line)
{
	F_LINE f;
	F_LINE f1;

	if (steps>MAX_STEPS) return f;

	double d[2*MAX_STEPS];
	double a1;

	int i;
	C_POINTd s[2];
	double m;
	int dmin;
	int k;
	for(i=0;i<2*steps+1;i++)
	{
		all_cell=0;
		if (i<=steps) a1=alfa-(double)alfa*i/steps;
		else a1=-(double)alfa*(i-steps)/steps;
		f=TurnLine(base_line,a1,point);
		if (f.b==1)
		{				
			s[0].x=point.x+(double)Step_line/sqrt((double)pow(f.b1,2)+1);				
			s[1].x=point.x-(double)Step_line/sqrt((double)pow(f.b1,2)+1);							
			s[0].y=(double)f.b1*s[0].x+f.b2;
			s[1].y=(double)f.b1*s[1].x+f.b2;
		}
		else
		{
			s[0].y=point.y+(double)Step_line/sqrt((double)pow(f.b1,2)+1);// 3.1.
			s[0].x=(double)f.b1*s[0].y+f.b2;
			s[1].y=point.y-(double)Step_line/sqrt((double)pow(f.b1,2)+1);
			s[1].x=(double)f.b1*s[1].y+f.b2;
		}
		OnBlackWhite(img,s[0].x,s[0].y,s[1].x,s[1].y,f);
		//     
		m=M_e(all_cell,leng_cell);
		d[i]=D_e(all_cell,leng_cell,m);
		if (i==0)  { dmin=i; f1=f;}
		else
		{
			if (absf(d[dmin]-d[i])<0.001 && abs(i-steps)<abs(dmin-steps)) { dmin=i; f1=f;}
			else 
				if (d[i]<d[dmin]) { dmin=i; f1=f;}
		}
	}
	//     1.3. -     
	double d1[2*MAX_STEPS];
	for(i=0;i<2*steps-3;i++)
	{
		//d1[i]=d[i]+d[i+1]+d[i+2];
		d1[i]=d[i]+d[i+1]+d[i+2]+d[i+3]+d[i+4];
		if (i==0) dmin=i;
		else 
			if (d1[i]<d1[dmin]) dmin=i;
	}

	//   
	for(i=0;i<2*steps-3-2;i++)
	{
		if (abs(i+1-dmin)<3)// 3.3
		if (d1[i+1]-d1[i]>0 && d1[i+2]-d1[i+1]<0)
		{
			if (absf(d1[i+1]-d1[i])>absf(d1[i+2]-d1[i+1])) dmin=i+1;
			else dmin=i+2;
			break;
		}
	}

	if (dmin+2<=steps) a1=alfa-(double)alfa*(dmin+2)/steps;
	else a1=-(double)alfa*((dmin+2)-steps)/steps;
	f1=TurnLine(base_line,a1,point);

#ifdef ON_DEBUG
	FILE *ff;
	ff=fopen("dd.log","w");
	char buf[256];
	int j;
	for(i=0;i<2*steps+1;i++)
	{
		sprintf(buf,"%7.5f\n",d[i]);
		for(j=0;j<strlen(buf);j++) if (buf[j]=='.') buf[j]=',';
		fputs(buf,ff);
	}
	fclose(ff);	
	ff=fopen("dd1.log","w");	
	for(i=0;i<2*steps-3;i++)
	{
		sprintf(buf,"%7.5f\n",d1[i]);
		for(j=0;j<strlen(buf);j++) if (buf[j]=='.') buf[j]=',';
		fputs(buf,ff);
	}
	fclose(ff);
#endif

	return f1;
}

/*
base_line -  ,   ,
point -   
point1 -   
alfa -   
steps -   ()   
*/
F_LINE AccuracyLine1(IMG img,F_LINE base_line,C_POINTd point,C_POINTd point1,double alfa,int steps)
{
	//        
	int see_color=5;
	if (steps<5) see_color=steps;
	F_LINE f;
	F_LINE f1;

	if (steps>MAX_STEPS) return f;

	double d[2*MAX_STEPS];
	double ddd1=0,ddd2=0;
	double a1;

	int i,j;
	C_POINTd s[2];
	double m;
	int dmin;
	int k;
	for(i=0;i<2*steps+1;i++)
	{
		all_cell=0;
		if (i<=steps) a1=alfa-(double)alfa*i/steps;
		else a1=-(double)alfa*(i-steps)/steps;
		f=TurnLine(base_line,a1,point);
		if (f.b==1)
		{	
			if (point1.x>point.x)
			{
				s[0].x=point.x;				
				s[1].x=point.x+(double)(point1.x-point.x)*1.0/sqrt((double)pow(f.b1,2)+1);				
			}
			else
			{
				s[0].x=point.x;				
				s[1].x=point.x-(double)(point.x-point1.x)*1.0/sqrt((double)pow(f.b1,2)+1);				
			}
			s[0].y=(double)f.b1*s[0].x+f.b2;
			s[1].y=(double)f.b1*s[1].x+f.b2;
		}
		else
		{
			if (point1.y>point.y)
			{
				s[0].y=point.y;
				s[1].y=point.y+(double)(point1.y-point.y)*1.0/sqrt((double)pow(f.b1,2)+1);
			}
			else
			{
				s[0].y=point.y;
				s[1].y=point.y-(double)(point.y-point1.y)*1.0/sqrt((double)pow(f.b1,2)+1);
			}			
			s[0].x=(double)f.b1*s[0].y+f.b2;			
			s[1].x=(double)f.b1*s[1].y+f.b2;
		}
		OnBlackWhite(img,s[0].x,s[0].y,s[1].x,s[1].y,f);

		//     
		if (all_cell>6)
		{
			j=0;k=1;
			if (!what_cell[0]) { j++; k=2;}
			m=M_e(all_cell-k,&leng_cell[j]);
			d[i]=D_e(all_cell-k,&leng_cell[j],m);
		}
		else d[i]=10000000;
		//if (i<steps) ddd1+=d[i];
		//if (i>steps) ddd2+=d[i];
		if (i<see_color)
			for(j=0;j<all_cell;j++)
				if (what_cell[j]) ddd1+=leng_cell[j];
		if (i>=2*steps+1-see_color)
			for(j=0;j<all_cell;j++)
				if (what_cell[j]) ddd2+=leng_cell[j];

	}
	double d1[2*MAX_STEPS];

	for(i=0;i<2*steps-4;i++)
	{
		//d1[i]=d[i]+d[i+1]+d[i+2];
		d1[i]=d[i]+d[i+1]+d[i+2]+d[i+3]+d[i+4];
		if (i==0) dmin=i;
		else 
			if (d1[i]<d1[dmin]) dmin=i;
	}
	int dmin1=dmin;
	//
	if (ddd1<ddd2)
	{
		for(i=dmin-1;i>=0;i--)
		{
			if (d1[i]<1.8*d1[dmin])
			{
				dmin1=i+1;
				//break;
			}
			else break;
		}
	}
	else 
	{
		for(i=dmin+1;i<2*steps-4;i++)
		{
			if (d1[i]<1.8*d1[dmin])
			{
				dmin1=i-1;
				//break;
			}
			else break;
		}
	}
	dmin=dmin1;
	
	if (dmin+2<=steps) a1=alfa-(double)alfa*(dmin+2)/steps;
	else a1=-(double)alfa*((dmin+2)-steps)/steps;
	f1=TurnLine(base_line,a1,point);

#ifdef ON_DEBUG
	FILE *ff;
	ff=fopen("dd.log","w");
	char buf[256];
	for(i=0;i<2*steps-5;i++)
	{
		sprintf(buf,"%7.5f\n",d[i]);
		for(j=0;j<strlen(buf);j++) if (buf[j]=='.') buf[j]=',';
		fputs(buf,ff);
	}
	fclose(ff);	
	ff=fopen("dd1.log","w");	
	for(i=0;i<2*steps-3;i++)
	{
		sprintf(buf,"%7.5f\n",d1[i]);
		for(j=0;j<strlen(buf);j++) if (buf[j]=='.') buf[j]=',';
		fputs(buf,ff);
	}
	fclose(ff);
#endif

	return f1;
}

/*
base_line -  ,   ,
point -   
point1 -   
alfa1 -     ,     
alfa2 -     ,  
steps -   ()   
*/
F_LINE AccuracyLine2(IMG img,F_LINE base_line,C_POINTd point,C_POINTd point1,double alfa1,double alfa2,int steps)
{
	F_LINE f1;
	F_LINE f;
	int i,j,j1;
	double a1;
	C_POINTd s[2];
	int k;
	double d,m,min;
	double dd=0;

	double L=LengthLine(point1.x,point1.y,point.x,point.y);

	// ,    ,         , 
	//,      -  
	int per_steps=steps/3;

	min=steps;
	int min1=0;
	int all=1;
	int param=0;
	double as[2];	
	for(i=0;i<2*steps+1;i++)
	{
		all_cell=0;
		if (i<steps) a1=alfa1-(double)alfa1*i/steps;
		if (i>steps)  a1=0-(double)alfa1*(i-steps)/steps;
		if (i==steps) f=base_line;
		else f=TurnLine(base_line,a1,point);
		if (f.b==1)
		{	
			if (point1.x>point.x)
			{
				s[0].x=point.x;				
				s[1].x=point.x+(double)L*1.0/sqrt((double)pow(f.b1,2)+1);				
			}
			else
			{
				s[0].x=point.x;				
				s[1].x=point.x-(double)L*1.0/sqrt((double)pow(f.b1,2)+1);				
			}
			s[0].y=(double)f.b1*s[0].x+f.b2;
			s[1].y=(double)f.b1*s[1].x+f.b2;
		}
		else
		{
			if (point1.y>point.y)
			{
				s[0].y=point.y;
				s[1].y=point.y+(double)L*1.0/sqrt((double)pow(f.b1,2)+1);
			}
			else
			{
				s[0].y=point.y;
				s[1].y=point.y-(double)L*1.0/sqrt((double)pow(f.b1,2)+1);
			}			
			s[0].x=(double)f.b1*s[0].y+f.b2;			
			s[1].x=(double)f.b1*s[1].y+f.b2;
		}
		OnBlackWhite(img,s[0].x,s[0].y,s[1].x,s[1].y,f);
		
		if (min1>0)
		{
			min1++;
			if (min1>=per_steps) break;
		}
		if (all_cell>7-what_cell[0]) 
		{
			j=0;k=1;
			if (!what_cell[0]) { j++; k=2;}
			m=M_e(all_cell-k,&leng_cell[j]);
			d=D_e(all_cell-k,&leng_cell[j],m);
			if (d<100)
			{
				//    
				m=0;
				for(j1=j;j1<all_cell-1;j1++)
					m+=leng_cell[j1];
				if (m>0.6*L)
				{
					param=min1-(1+per_steps/10);
					if (param<0) param=0;
					//  
					as[0]=(double)sqrt((double)dd)/pow((double)all,1.7);
					as[1]=(double)sqrt((double)d+param)/pow((double)all_cell-k,1.7);
					if (min1<=2 || as[0]>as[1] )
					{
						min=i;
						dd=d+param;
						all=all_cell-k;
					}
					if (min1>=per_steps) break;
					if (min1==0) min1++;
					//break;
				}
			}
		}
	}

	if (min<steps) a1=alfa1-(double)alfa1*min/steps;
	if (min>steps)  a1=0-(double)alfa1*(min-steps)/steps;
	if (min==steps) f1=base_line;
	else f1=TurnLine(base_line,a1,point);

	return f1;
}

/*
base_line -  ,   ,
point -   
point1 -   
alfa1 -     ,     
alfa2 -     ,  
steps -   ()   
   
*/
F_LINE AccuracyLineBlack(IMG img,F_LINE base_line,C_POINTd point,C_POINTd point1,double alfa1,double alfa2,int steps)
{
	F_LINE f1;
	F_LINE f;
	int i,j;
	double a1;
	C_POINTd s[2];
	double L=LengthLine(point1.x,point1.y,point.x,point.y);

	int *all=new int[2*steps+1];
	int *all1=new int[2*steps+1];
	int max=-1;

	for(i=0;i<2*steps+1;i++)
	{
		all_cell=0;
		if (i<steps) a1=alfa1-(double)alfa1*i/steps;
		if (i>steps)  a1=0-(double)alfa1*(i-steps)/steps;
		if (i==steps) f=base_line;
		else f=TurnLine(base_line,a1,point);
		if (f.b==1)
		{	
			if (point1.x>point.x)
			{
				s[0].x=point.x;				
				s[1].x=point.x+(double)L*1.0/sqrt((double)pow(f.b1,2)+1);				
			}
			else
			{
				s[0].x=point.x;				
				s[1].x=point.x-(double)L*1.0/sqrt((double)pow(f.b1,2)+1);				
			}
			s[0].y=(double)f.b1*s[0].x+f.b2;
			s[1].y=(double)f.b1*s[1].x+f.b2;
		}
		else
		{
			if (point1.y>point.y)
			{
				s[0].y=point.y;
				s[1].y=point.y+(double)L*1.0/sqrt((double)pow(f.b1,2)+1);
			}
			else
			{
				s[0].y=point.y;
				s[1].y=point.y-(double)L*1.0/sqrt((double)pow(f.b1,2)+1);
			}			
			s[0].x=(double)f.b1*s[0].y+f.b2;			
			s[1].x=(double)f.b1*s[1].y+f.b2;
		}
		OnBlackWhite(img,s[0].x,s[0].y,s[1].x,s[1].y,f);
		
		all[i]=0;
		for(j=0;j<all_cell;j++)
			if (what_cell[j]) all[i]+=leng_cell[j];

		/*if (max==-1) max=0;
		else
		{
			if (all[i]>all[max]) max=i;
		}*/
		
	}

	max=0;
	for(i=0;i<2*steps-3;i++)
	{
		all1[i]=all[i+0]+all[i+1]+all[i+2]+all[i+3]+all[i+4];
		if (i>0)
			if (all1[i]>all1[max]) max=i;
	}

	max+=3;

#ifdef ON_DEBUG
	FILE *ff;
	ff=fopen("black.log","w");
	char buf[256];
	for(i=0;i<2*steps+1;i++)
	{
		sprintf(buf,"%d\n",all[i]);		
		fputs(buf,ff);
	}
	fclose(ff);	
	
	ff=fopen("black1.log","w");
	
	for(i=0;i<2*steps-3;i++)
	{
		sprintf(buf,"%d\n",all1[i]);		
		fputs(buf,ff);
	}
	fclose(ff);	

#endif

	delete all;
	delete all1;

	if (max<steps) a1=alfa1-(double)alfa1*max/steps;
	if (max>steps)  a1=0-(double)alfa1*(max-steps)/steps;
	if (max==steps) f1=base_line;
	else f1=TurnLine(base_line,a1,point);

	return f1;
}


//
int OnBlackWhite(IMG img,double x1,double y1,double x2,double y2,F_LINE f3)
{
	//      
	int j,i1,j2,j1,i2;
	   all_cell=0;
	   j=-1;
	   do{
			i1=1;
			if (f3.b==1)
			{
				//y=f(x)
				if (x2<x1) i1=-1;
				j2=round(x1+i1*j);
				if (j2==round(x2+i1)) break;
				i2=round((double)f3.b1*j2+f3.b2);					
			}
			else
			{
				//x=f(y)
				if (y2<y1) i1=-1;
				i2=y1+i1*j;
				if (i2==round(y2+i1)) break;
				j2=round((double)f3.b1*i2+f3.b2);					
			}
			j1=BlackWhite(img,j+1,j2,i2);	
			if (j1>=2) break;
			j++;
		}while(true);	
	return 0;
}

//       
int BlackWhite(IMG img,int j,int x,int y)
{
	if (x<0 || y<0) return 0;
	if (y>=img.Height || x>=img.Width) return 0;
	if (j==0)
	{
		leng_cell[0]=1;
		if (img.bytes[x+y*img.Width_1]!=0) what_cell[0]=false;
		else what_cell[0]=true;
		all_cell=1;
		return 1;
	}
	if (img.bytes[x+y*img.Width_1]!=0)
	{
		if (!what_cell[all_cell-1]) leng_cell[all_cell-1]++;
		else {
			what_cell[all_cell]=false;
			leng_cell[all_cell]=1;
			all_cell++;
			if (all_cell>=MAX_CELL_LATTICE) return 2;
		}
	}
	else
	{
		if (what_cell[all_cell-1]) leng_cell[all_cell-1]++;
		else {
			what_cell[all_cell]=true;
			leng_cell[all_cell]=1;
			all_cell++;
			if (all_cell>=MAX_CELL_LATTICE) return 2;
		}
	}

	return 0;
}


int ReturnDifference(IMG img,double x1,double y1,double x2,double y2,F_LINE f3,DWORD flags)
{
	OnBlackWhite(img,x1,y1,x2,y2,f3);

	int j=all_cell;

	if ((DIFFERENCE_BLACK_BLACK&flags)==DIFFERENCE_BLACK_BLACK)
	{
		//         
		if (!what_cell[0]) j--;
		if (!what_cell[all_cell-1]) j--;
	}


	return j;
}


C_POINTd ReturnFirstPoint(IMG img,F_LINE f,C_POINTd point1,C_POINTd point2,BYTE color, BYTE color1)
{
	C_POINTd p;

	p.x=-1;p.y=-1;
	if (img.format!=1) return p;

	C_POINTd p_t;	
	C_POINT p_t1;	
	
	
	p_t.x=point1.x;
	p_t.y=point1.y;
	do{
		if (f.b==1)
		{
			if (point2.x>point1.x) p_t.x++;
			else p_t.x--;
			p_t.y=(double)f.b1*p_t.x+f.b2;
			if ((p_t.x<point1.x && p_t.x<point2.x) || (p_t.x>point1.x && p_t.x>point2.x)) break;
		}
		if (f.b==2)
		{
			if (point2.y>point1.y) p_t.y++;
			else p_t.y--;
			p_t.x=(double)f.b1*p_t.y+f.b2;
			if ((p_t.y<point1.y && p_t.y<point2.y) || (p_t.y>point1.y && p_t.y>point2.y)) break;
		}
		p_t1=PointDI(p_t);
		if (p_t1.x<0 || p_t1.x>=img.Width || p_t1.y<0 || p_t1.y>=img.Height) continue;
		if (img.bytes[p_t1.x+p_t1.y*img.Width_1]==color || img.bytes[p_t1.x+p_t1.y*img.Width_1]==color1)
		{
			p=p_t;
			break;
		}
	}while(1);	

	return p;
}



//   ,  ReturnDifference
int *ReturnArrayBlackWhite(DWORD flags)
{
	int *ptr;
	ptr=&leng_cell[0];

	if ((DIFFERENCE_BLACK_BLACK&flags)==DIFFERENCE_BLACK_BLACK)
		if (!what_cell[0]) ptr=&leng_cell[1];

	return ptr;
}

//          what_cell*10000
int ReturnNumArray(int num)
{
	return what_cell[num]*10000+leng_cell[num];
}