/*	______________________________________________________________________

	geometry.h  Version 1.02
	(C)2010. Kruchinin Aleksandr. http://vidikon.com
	 	
	______________________________________________________________________
*/
#ifndef _GEOMETRY_
#define _GEOMETRY_ 1

//#define BUILD_DLL

#define IMAGEPAK __declspec(dllexport) 
 


#include <stdio.h>
#include <math.h>



#define PI 3.14159265358979323846

struct F_LINE
{
	int k1;
	int b;
	double b1,b2;
};

struct C_POINT
{
	int x,y;
};

struct C_POINTd
{
	double x,y;
};

//   4 
/*
0 ----- 2
|       |
3 ----- 1
*/
struct FOUR_FIG_P
{
	C_POINT p[4];//0,1  -   2,3 - 
};

struct FOUR_FIG_Pd
{
	C_POINTd p[4];//0,1  -   2,3 - 
};

//   4 
//   02-21-13-30
struct FOUR_FIG_L
{
	F_LINE l[4];
};


//   
IMAGEPAK F_LINE MakeLine(double x1,double y1,double x2,double y2);
IMAGEPAK F_LINE MakeLine(C_POINT p1,C_POINT p2);
IMAGEPAK F_LINE MakeLine(C_POINTd p1,C_POINTd p2);

extern "C"
{

IMAGEPAK F_LINE MakeLineFromPolar(C_POINTd p1,double f);

}

//        (    ) 
IMAGEPAK C_POINTd FindPointContinue(C_POINTd p1,C_POINTd p2,F_LINE line,double size);
IMAGEPAK C_POINTd FindPointContinue_(C_POINTd p1,C_POINTd p2,F_LINE line,double size);

extern "C"
{

IMAGEPAK int Intersection(F_LINE f1,F_LINE f2,double &x,double &y);//  

//   
IMAGEPAK double LengthLine(double x1,double y1,double x2,double y2);

// 
IMAGEPAK float MakePolarR(float x,float y);
IMAGEPAK float MakePolarF(float x,float y);

#define DIRECT_HOUR_ARROW 0x01	// 
#define DIRECT_HOUR_ARROW_A 0x02	//
//   -     
IMAGEPAK bool DirectPoint(C_POINT*p,int all,unsigned char flags);


IMAGEPAK C_POINTd PointID(C_POINT p);
IMAGEPAK C_POINT PointDI(C_POINTd p);

}


IMAGEPAK double RToLine(F_LINE f,double x,double y);//    
IMAGEPAK double RToLine(F_LINE f,C_POINTd p);

extern "C"
{

IMAGEPAK int round(double param);
IMAGEPAK double absf(double a);

//  
IMAGEPAK C_POINTd Average(C_POINTd p1,C_POINTd p2);

//  
IMAGEPAK F_LINE MakeParallelLine(F_LINE line,C_POINTd point);

//        
IMAGEPAK double FoundInclination(F_LINE line,F_LINE line1);

//     
IMAGEPAK F_LINE TurnLine(F_LINE f,double alfa,C_POINTd point);

//   
IMAGEPAK F_LINE Approximation(int *array,int all_elem);

}

#endif