/*	______________________________________________________________________

	segment.cpp  Version 1.00
	(C)2010. Kruchinin Aleksandr. http://vidikon.com
	
	______________________________________________________________________
*/

#include "segment.h"

#define COLORS_VAR 27
#define ALL_MAXIM 20

byte colors_seg[COLORS_VAR*3]=
{
	255,255,255,
	0,255,255,
	255,0,255,
	255,255,0,
	0,0,255,
	0,255,0,
	255,0,0,
	0,0,0,
	128,128,128,
	0,128,128,
	128,0,128,
	128,128,0,
	0,0,128,
	0,128,0,
	128,0,0,
	255,128,128,
	128,255,128,
	128,128,255,
	255,255,128,
	255,128,255,
	128,255,255,
	255,128,0,
	255,0,128,
	128,255,0,
	128,0,255,
	0,128,255,
	0,255,128,
};

/*    
Segment -  
Hist -           4
param -  
*/
SEGMENTSH SegmentationH(IMG Img,int Segment,int Hist,double param,double Binary,DWORD flags)
{
	SEGMENTSH ss;
	ss.Width=-1;
	if (Img.format!=1 || Segment<2 || Segment>1024 || Hist<1 || Hist>256) return ss;

	ss.Height=Img.Height/Segment;
	ss.Width=Img.Width/Segment;

	ss.ptr=new int[ss.Height*ss.Width];
	ss.binary=new bool[ss.Height*ss.Width];
	memset((void*)ss.ptr,-1,ss.Height*ss.Width*sizeof(int));

	HISTO_1D* hh=new HISTO_1D[ss.Height*ss.Width];

	int i,j,k,i1,j1;
	RECT r;

	//int a[3];
	int ma[ALL_MAXIM];
	double *a=new double[3+Hist];
	int ma_max;
	int max;
	long bb,bb1;
	// 
	for(i=0;i<ss.Height;i++)
		for(j=0;j<ss.Width;j++)
		{
			r.left=j*Segment;
			r.right=(j+1)*Segment-1;
			r.top=i*Segment;
			r.bottom=(i+1)*Segment-1;
			hh[i*ss.Width+j]=MakeHistogramIMG(Img,r,Hist);

			if ((SEG_BINARY_ON&flags)==SEG_BINARY_ON) 
			{
				//    
				/*a[0]=0;a[1]=0;a[2]=0;		
				for(k=0;k<6*Hist/16;k++)
					a[0]+=hh[i*ss.Width+j].data[k];
				for(k=10*Hist/16;k<Hist;k++)
					a[1]+=hh[i*ss.Width+j].data[k];
				for(k=5*Hist/16;k<11*Hist/16;k++)
					a[2]+=hh[i*ss.Width+j].data[k];
				if (a[2]<a[0]*0.75 && a[2]<a[1]*0.75) ss.binary[i*ss.Width+j]=1;
				else ss.binary[i*ss.Width+j]=0;*/
				//    
				//1.   ,   
				ma_max=0;
				for(k=0;k<Hist;k++)
				{
					if (k==0)
					{
						a[k]=hh[i*ss.Width+j].data[k]+(double)hh[i*ss.Width+j].data[k+1]/2;
						continue;
					}
					if (k==Hist-1) a[k]=hh[i*ss.Width+j].data[k]+(double)hh[i*ss.Width+j].data[k-1]/2;
					else
						a[k]=hh[i*ss.Width+j].data[k]+(double)hh[i*ss.Width+j].data[k-1]/2+
							 (double)hh[i*ss.Width+j].data[k+1]/2;
				}
				max=-1;
				for(k=0;k<Hist;k++)
				{
					if ((k==0 && a[0]>a[1]) || (k==Hist-1 && a[Hist-1]>a[Hist-2]) ||
						(k>0 && k<Hist-1 && a[k]>a[k-1] && a[k]>=a[k+1]))
					{						
						ma[ma_max]=k;
						if (max==-1) max=k;
						else if (a[max]<a[k]) max=k;
						ma_max++;
						if (ma_max>=ALL_MAXIM) break;
					}
				}
				if (ma_max>1)
				{
					//2.    (..    )
					i1=-1;
					for(k=0;k<ma_max;k++)
						if (ma[k]!=max)
						{
							if (i1==-1)
							{
								i1=ma[k];
								a[0]=(double)abs(ma[k]-max)/Hist-(double)hh[i*ss.Width+j].data[ma[k]]/hh[i*ss.Width+j].data[max];
							}
							else
							{
								a[1]=(double)abs(ma[k]-max)/Hist-(double)hh[i*ss.Width+j].data[ma[k]]/hh[i*ss.Width+j].data[max];
								if (a[1]>a[0])
								{
									i1=ma[k];
									a[0]=a[1];
								}
							}
						}
					//i1 -   
					//3.   
					if ((double)abs(i1-max)<(double)Hist/3) ss.binary[i*ss.Width+j]=0;
					else
					{
						j1=abs(i1-max)/4;
						bb=0;
						bb1=0;
						for(k=0;k<Hist;k++)
						{
							if (abs(k-i1)<=j1) bb+=hh[i*ss.Width+j].data[k];
							if (abs(k-max)<=j1) bb1+=hh[i*ss.Width+j].data[k];
						}
					
						if ((double)bb1+bb>(double)Binary*Segment*Segment && (double)bb1>(double)Binary*Segment*Segment/4
							&& (double)bb>(double)Binary*Segment*Segment/4) 
						{
							ss.binary[i*ss.Width+j]=1;
						}
						else ss.binary[i*ss.Width+j]=0;
					}
				}
				else ss.binary[i*ss.Width+j]=0;
			}
		}
	delete a;

	//      
	int *sx=new int[ss.Height*ss.Width];
	int *sy=new int[ss.Height*ss.Width];
	int *ptr1=new int[ss.Height*ss.Width];
	int *ptr2=new int[ss.Height*ss.Width];//   	
	int all_ptr2=0;
	int all_ptr=0;	
	ss.AllDifSeg=0;
	int x,y;
	double kpk1;	
	int k1;
	for(i=0;i<ss.Height;i++)
		for(j=0;j<ss.Width;j++)
			if (ss.ptr[i*ss.Width+j]==-1)
			{
				ss.ptr[i*ss.Width+j]=ss.AllDifSeg;
				ss.AllDifSeg++;
				//   -     
				all_ptr=0;
				i1=i;j1=j;
				k1=0;
				do{
					for(k=0;k<9;k++)
						if (k!=4)
						{
							x=j1-1+k%3;
							y=i1-1+k/3;							
							if (x<0 || y<0 || x>=ss.Width || y>=ss.Height) continue;
							if (ss.ptr[y*ss.Width+x]!=-1) continue;

							// 0  1
							kpk1=(double)CompareHist(hh[i1*ss.Width+j1],hh[y*ss.Width+x],HIST_COMP_CHISQR)/(2*hh[i1*ss.Width+j1].pixels);
							
							if (kpk1<=param)
							{
								//     
								ss.ptr[y*ss.Width+x]=ss.ptr[i1*ss.Width+j1];
								ptr1[all_ptr]=y*ss.Width+x;
								all_ptr++;
								k1=1;
							}							
							//printf("%5.3f\n",kpk1);
						}
					if (all_ptr<1) break;
					i1=ptr1[all_ptr-1]/ss.Width;
					j1=ptr1[all_ptr-1]%ss.Width;
					all_ptr--;
				}
				while(1);
				//   
				if ((SEG_NO_SMALL&flags)==SEG_NO_SMALL) 
					if (k1==0) 
					{
						ptr2[all_ptr2]=i*ss.Width+j;;
						all_ptr2++;
					}
			}
	//  
	if ((SEG_NO_SMALL&flags)==SEG_NO_SMALL) 
	{
		double param_[9];
		int min;
		param_[4]=10;		
		for(i=0;i<all_ptr2;i++)
		{
			i1=ptr2[i]/ss.Width;
			j1=ptr2[i]%ss.Width;
			k1=-1;
			for(k=0;k<9;k++)
				if (k!=4)
				{
					x=j1-1+k%3;
					y=i1-1+k/3;	
					if (x<0 || y<0 || x>=ss.Width || y>=ss.Height) 
					{
						param_[k]=10;
						continue;
					}
					param_[k]=(double)CompareHist(hh[i1*ss.Width+j1],hh[y*ss.Width+x],HIST_COMP_CHISQR)/(2*hh[i1*ss.Width+j1].pixels);
					if (k1==-1) min=k;
					else
					{
						if (param_[k]<param_[min]) min=k;
					}
				}
			x=j1-1+min%3;
			y=i1-1+min/3;	
			ss.ptr[i1*ss.Width+j1]=ss.ptr[y*ss.Width+x];
			hh[i1*ss.Width+j1]=hh[y*ss.Width+x];
		}
	}

	delete hh;
	delete sx;
	delete sy;
	delete ptr1;
	delete ptr2;


	return ss;
}



void DrawSegmentsH(IMG Img,SEGMENTSH ss,int Segment/**/,DWORD flags)
{
	if (Img.format!=0) return;
	int i,j;
	byte a,b;
	RECT r;
	int *onoff=new int[ss.AllDifSeg];
	memset((void*)onoff,0,ss.AllDifSeg*sizeof(int));
	if ((SEG_BINARY_FULL&flags)==SEG_BINARY_FULL) 
		for(i=0;i<ss.Height;i++)
			for(j=0;j<ss.Width;j++)
				if (onoff[ss.ptr[i*ss.Width+j]]!=1)
					if (ss.binary[i*ss.Width+j]) onoff[ss.ptr[i*ss.Width+j]]=1;
	if ((SEG_BINARY_MAX&flags)==SEG_BINARY_MAX)
		for(i=0;i<ss.Height;i++)
			for(j=0;j<ss.Width;j++)
				if (ss.binary[i*ss.Width+j]) onoff[ss.ptr[i*ss.Width+j]]++;
	int max=0;
	for(i=1;i<ss.AllDifSeg;i++)
		if (onoff[i]>onoff[max]) max=i;
	for(i=0;i<ss.Height;i++)
		for(j=0;j<ss.Width;j++)
		{
			if ((SEG_BINARY_ON&flags)==SEG_BINARY_ON) 
				if (!ss.binary[i*ss.Width+j]) continue;
			if ((SEG_BINARY_FULL&flags)==SEG_BINARY_FULL) 
				if (onoff[ss.ptr[i*ss.Width+j]]==0) continue;
			if ((SEG_BINARY_MAX&flags)==SEG_BINARY_MAX) 
				if (ss.ptr[i*ss.Width+j]!=max) continue;
			r.left=j*Segment;
			r.right=(j+1)*Segment-1;
			r.top=i*Segment;
			r.bottom=(i+1)*Segment-1;
			DrawFillRect(Img,r,colors_seg[(ss.ptr[i*ss.Width+j]%COLORS_VAR)*3],colors_seg[(ss.ptr[i*ss.Width+j]%COLORS_VAR)*3+1],
				colors_seg[(ss.ptr[i*ss.Width+j]%COLORS_VAR)*3+2]);
		}
	delete onoff;
}

void DeleteSegmentsh(SEGMENTSH ss)
{
	if (ss.ptr!=NULL) delete ss.ptr;
	if (ss.binary!=NULL) delete ss.binary;
}

/*
ss - ,  SegmentationH
Rect -   RECT
elem -       ,   Rect
maxrect -  Rect
*/
int ReturnRectSegmentsh(SEGMENTSH ss,int Segment/**/,RECT &Rect,int elem,int maxrect,DWORD flags)
{
	RECT* Rect_=&Rect;
	int *p=new int[ss.AllDifSeg];
	memset((void*)p,0,ss.AllDifSeg*sizeof(int));

	int i,j;
	for(i=0;i<ss.Height;i++)
		for(j=0;j<ss.Width;j++)
			if (ss.binary[i*ss.Width+j])
				p[ss.ptr[i*ss.Width+j]]++;
	j=0;
	int i1,j1;
	int max=-1;
	int max1=-1;
	for(i=0;i<ss.AllDifSeg;i++)
		if (p[i]>=elem)
		{
			if (j>=maxrect) break;
			if (max==-1) { max=j; max1=i;}
			else
				if (p[max1]<p[i]) {max=j; max1=i;}
			// Rect
			Rect_[j].left=-1;
			for(i1=0;i1<ss.Height;i1++)
				for(j1=0;j1<ss.Width;j1++)
					if (ss.ptr[i1*ss.Width+j1]==i)
					{
						if (Rect_[j].left<0)
						{
							Rect_[j].left=j1*Segment;
							Rect_[j].right=(j1+1)*Segment-1;
							Rect_[j].top=i1*Segment;
							Rect_[j].bottom=(i1+1)*Segment-1;
						}
						else
						{
							if (j1*Segment<Rect_[j].left) Rect_[j].left=j1*Segment;
							if ((j1+1)*Segment-1>Rect_[j].right) Rect_[j].right=(j1+1)*Segment-1;
							if (i1*Segment<Rect_[j].top) Rect_[j].top=i1*Segment;
							if ((i1+1)*Segment-1>Rect_[j].bottom) Rect_[j].bottom=(i1+1)*Segment-1;
						}
					}
			j++;
		}
	if ((SEG_BINARY_MAX&flags)==SEG_BINARY_MAX)
	{
		if (max>0)
			Rect_[0]=Rect_[max];
		if (j>1) j=1;
	}
	delete p;
	return j;
}